LIBRARY IEEE;
USE IEEE.std_logic_1164.ALL;

ENTITY dsp_z IS
	PORT (
		fuera : IN std_logic; 	
		dsp_buf : OUT std_logic_vector(0 to 48)
		);
END dsp_z;

ARCHITECTURE arq_dsp_z OF dsp_z IS
	SIGNAL kk : std_logic;
BEGIN
-- Se dejan las salidas dsp_buf[0..48] en alta impedancia, estan conectadas al dsp que de otro modo se 
-- conectarian a "0" provocando cortocircuitos que sobrecalientan la FPGA.
	
	PROCESS
		BEGIN
		IF fuera = '0' THEN
			dsp_buf <= "ZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZ";
			kk <= '0';
		ELSE
			kk <= '1';
			IF kk = '1' THEN
				dsp_buf <= "0000000000000000000000000000000000000000000000000";
			ELSIF kk = '0' THEN
				dsp_buf <= "1111111111111111111111111111111111111111111111111";
			END IF;
		END IF;
	END PROCESS;
END arq_dsp_z;
