LIBRARY IEEE;
USE IEEE.std_logic_1164.ALL;

PACKAGE datos IS
	CONSTANT width_address_ram	:	INTEGER := 7;	
	CONSTANT width_data		:	INTEGER := 63;
	TYPE address_f_ram IS ARRAY(0 to width_address_ram) OF std_logic;	
	TYPE data_f IS ARRAY(0 to width_data) OF std_logic;		
	TYPE stages IS (atent,activa,recull,prepara,graba); 		
	TYPE stages90 IS (atent,lectura,lee,graba,suelta);	

END datos;

LIBRARY IEEE;
USE IEEE.std_logic_1164.ALL;
USE IEEE.STD_LOGIC_ARITH.ALL; 
USE WORK.datos.ALL;

ENTITY ram_ctrl11_syn IS											
	PORT ( 	
			clk : IN std_logic;
			clk90 : IN std_logic;
			escriu : IN std_logic;		
			add_ram	: IN address_f_ram;
			ent_dio : IN std_logic_vector (0 to width_data);
			llegirb : IN std_logic;		
			add_ramb : IN address_f_ram;
			llegirc : IN std_logic;		
			add_ramc : IN address_f_ram;			
			sal_dio : OUT std_logic_vector (0 to width_data);
			add : OUT address_f_ram;
			we : OUT std_logic;
			outen : OUT std_logic;
			memenab : OUT std_logic;
			dio : INOUT std_logic_vector (0 to width_data);
			led_3 : OUT std_logic
		);
END ram_ctrl11_syn;

ARCHITECTURE arq_ram_ctrl11_syn OF ram_ctrl11_syn IS
	SIGNAL st : stages;
	SIGNAL st90 : stages90;
	SIGNAL num : integer;
--	SIGNAL dio_aux : std_logic_vector (width_data downto 0);	
	SIGNAL dio_aux : std_logic_vector (0 to width_data);	
	
BEGIN
	PROCESS(clk)		
		BEGIN
		IF st90 = graba or st = graba or st90 = suelta THEN
			dio <= dio_aux;
		ELSE
			dio <= "ZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZ"; 
		END IF;
	END PROCESS;
	
	PROCESS(clk90)
		BEGIN
		IF rising_edge(clk90) THEN
			CASE st90 IS
				WHEN atent =>			
					st <= atent;
				WHEN lectura =>
					we <= '0';
					st <= activa;
				WHEN lee =>
--					we <= '1';
					st <= recull;
				WHEN graba =>		
					IF num = 0 THEN
						num <= num + 1;
						we <= '1';
					ELSE
						num <= 0;
						st <= graba;
					END IF;
				WHEN suelta =>	
					we <= '0';
					st <= atent;				
			END CASE;
		END IF;
	END PROCESS;
	PROCESS(clk)
		BEGIN
		IF rising_edge(clk) THEN
			CASE st IS
				WHEN atent =>
					IF escriu = '1' THEN
						outen <= '0';					
						memenab <= '1';
						add <= add_ram;		
						dio_aux <= ent_dio;
						st90 <= graba;
						led_3 <= '1';
					ELSIF llegirb = '1' THEN
						outen <= '0';	
						memenab <= '0';						
						add <= add_ramb;										
						st90 <= lectura;
					ELSIF llegirc = '1' THEN
						outen <= '0';					
						memenab <= '0';
						add <= add_ramc;							
						st90 <= lectura;
					ELSE
						st90 <= atent;
						outen <= '0';				
						memenab <= '0';
					END IF;
				WHEN activa =>
					outen <= '1';	
					memenab <= '1';
					st90 <= lee;
				WHEN recull =>
					sal_dio <= dio;	
					st90 <= atent;
				WHEN prepara =>
					memenab <= '1';
					st90 <= graba;
				WHEN graba =>
					st90 <= suelta;
				END CASE;
		END IF;
	END PROCESS;
END arq_ram_ctrl11_syn;
	
	
	
